/**
 * ...
 * @author 
 */
class OOFilterCmp extends OOFilter
{
	
	function _populateProperties() {
		super._populateProperties();
		
			this.editableProperties.unshift(
			{name:'dropShadowFilterEnabled', description:'PROPERTIES_DROP_SHADOW_ENABLED', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN, defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'dropShadowDistance', description:'PROPERTIES_DROP_SHADOW_DISTANCE', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, defaultValue:5, isRegistered:true, group:'attributes' },
			{name:'dropShadowAngle', description:'PROPERTIES_DROP_SHADOW_ANGLE', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, defaultValue:0, isRegistered:true, group:'attributes' },
			{name:'dropShadowBlurX', description:'PROPERTIES_DROP_SHADOW_BLUR_X', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'dropShadowBlurY', description:'PROPERTIES_DROP_SHADOW_BLUR_Y', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'dropShadowAlpha', description:'PROPERTIES_DROP_SHADOW_ALPHA', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, maxValue:1, defaultValue:100, isRegistered:true, group:'attributes' },
			{name:'dropShadowColor', description:'PROPERTIES_DROP_SHADOW_COLOR', type:silexInstance.constants.PROPERTIES_TYPE_COLOR , defaultValue:0, isRegistered:true, group:'attributes' },
			{name:'dropShadowIsInner', description:'PROPERTIES_DROP_SHADOW_IS_INNER', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'dropShadowKnockout', description:'PROPERTIES_DROP_SHADOW_KNOCKOUT', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'dropShadowQuality', description:'PROPERTIES_DROP_SHADOW_QUALITY', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , defaultValue:1, minValue:0, maxValue:15, isRegistered:true, group:'attributes' },
			{name:'dropShadowStrength', description:'PROPERTIES_DROP_SHADOW_STRENGTH', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , defaultValue:1, minValue:0, maxValue:255, isRegistered:true, group:'attributes' },
			
			{name:'blurFilterEnabled', description:'PROPERTIES_BLUR_FILTER_ENABLED', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'blurBlurX', description:'PROPERTIES_BLUR_FILTER_BLUR_X', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'blurBlurY', description:'PROPERTIES_BLUR_FILTER_BLUR_Y', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'blurQuality', description:'PROPERTIES_BLUR_FILTER_QUALITY', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , minValue:0, maxValue:15, defaultValue:1, isRegistered:true, group:'attributes' },
			
			{name:'glowFilterEnabled', description:'PROPERTIES_GLOW_FILTER_ENABLED', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'glowAlpha', description:'PROPERTIES_GLOW_FILTER_ALPHA', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , minValue:0, maxValue:1, defaultValue:1, isRegistered:true, group:'attributes' },
			{name:'glowBlurX', description:'PROPERTIES_GLOW_FILTER_BLUR_X', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'glowBlurY', description:'PROPERTIES_GLOW_FILTER_BLUR_Y', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'glowColor', description:'PROPERTIES_GLOW_FILTER_COLOR', type:silexInstance.constants.PROPERTIES_TYPE_COLOR , defaultValue:0, isRegistered:true, group:'attributes' },
			{name:'glowIsInner', description:'PROPERTIES_GLOW_FILTER_IS_INNER', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'glowKnockout', description:'PROPERTIES_GLOW_FILTER_KNOCKOUT', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'glowQuality', description:'PROPERTIES_GLOW_FILTER_QUALITY', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , defaultValue:1, minValue:0, maxValue:15, isRegistered:true, group:'attributes' },
			{name:'glowStrength', description:'PROPERTIES_GLOW_FILTER_STRENGTH', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , defaultValue:2, minValue:0, maxValue:255, isRegistered:true, group:'attributes' },
			
			{name:'bevelFilterEnabled', description:'PROPERTIES_BEVEL_ENABLED', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN, defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'bevelDistance', description:'PROPERTIES_BEVEL_DISTANCE', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, defaultValue:5, isRegistered:true, group:'attributes' },
			{name:'bevelAngle', description:'PROPERTIES_BEVEL_ANGLE', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, defaultValue:0, isRegistered:true, group:'attributes' },
			{name:'bevelBlurX', description:'PROPERTIES_BEVEL_BLUR_X', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'bevelBlurY', description:'PROPERTIES_BEVEL_BLUR_Y', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, defaultValue:3, isRegistered:true, group:'attributes' },
			{name:'bevelShadowAlpha', description:'PROPERTIES_BEVEL_SHADOW_ALPHA', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, maxValue:1, defaultValue:100, isRegistered:true, group:'attributes' },
			{name:'bevelShadowColor', description:'PROPERTIES_BEVEL_SHADOW_COLOR', type:silexInstance.constants.PROPERTIES_TYPE_COLOR , defaultValue:0, isRegistered:true, group:'attributes' },
			{name:'bevelHighlightAlpha', description:'PROPERTIES_BEVEL_HIGHLIGHT_ALPHA', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER, minValue:0, maxValue:1, defaultValue:100, isRegistered:true, group:'attributes' },
			{name:'bevelHighlightColor', description:'PROPERTIES_BEVEL_HIGHLIGHT_COLOR', type:silexInstance.constants.PROPERTIES_TYPE_COLOR , defaultValue:0, isRegistered:true, group:'attributes' },
			{name:'bevelKnockout', description:'PROPERTIES_BEVEL_KNOCKOUT', type:silexInstance.constants.PROPERTIES_TYPE_BOOLEAN , defaultValue:false, isRegistered:true, group:'attributes' },
			{name:'bevelQuality', description:'PROPERTIES_BEVEL_QUALITY', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , defaultValue:1, minValue:0, maxValue:15, isRegistered:true, group:'attributes' },
			{name:'bevelStrength', description:'PROPERTIES_BEVEL_STRENGTH', type:silexInstance.constants.PROPERTIES_TYPE_NUMBER , defaultValue:1, minValue:0, maxValue:255, isRegistered:true, group:'attributes' },
			{name:'bevelType', description:'PROPERTIES_BEVEL_TYPE', type:silexInstance.constants.PROPERTIES_TYPE_ENUM , defaultValue:"inner", values:["inner", "outer", "full"], isRegistered:true, group:'attributes' }
			
			
		);
	}
	
}